#define F_CPU 1000000

#include <avr/io.h>
#include <string.h>
#include <util/delay.h>
#include <avr\interrupt.h>




//*******************************************************************************************
//  MOJE UPRAVY
//-------------------------------------------------------------------------------------------
//
#define setb(port,pin)    port |= 1<<pin    //nastav bit
#define clrb(port,pin)    port &= ~(1<<pin) //nuluj bit
#define negb(port,pin)    port ^= 1<<pin    //neguj bit


#define BIT0 0x01
#define BIT1 0x02
#define BIT2 0x04
#define BIT3 0x08
#define BIT4 0x10
#define BIT5 0x20
#define BIT6 0x40
#define BIT7 0x80

#define SDA1_H PORTD |= BIT0		//data pro radic 1
#define SDA1_L PORTD &= ~BIT0 

#define SCLK1_H PORTD |= BIT1		//casovy signal pro radic 1
#define SCLK1_L PORTD &= ~BIT1

#define SDA2_H PORTD |= BIT2		//data pro radic 2
#define SDA2_L PORTD &= ~BIT2 

#define SCLK2_H PORTD |= BIT3		//casovy signal pro radic 2
#define SCLK2_L PORTD &= ~BIT3

#define CH_0 0
#define CH_1 1

#define HLAD_MIN_BIT	BIT4
#define HLAD_POZ_BIT	BIT6
#define HLAD_MAX_BIT	BIT5

#define CER1 5
#define CER2 5
#define CER3 5
#define CER4 10

//***********************************************************************************

void pwm_vyska(unsigned char sirka_pulzu1); //pro vysku hladiny
void pwm_rychlost(unsigned char sirka_pulzu2);
unsigned char read_adc(unsigned char kanal); //mereni ad prevodniku, vraci 0-255
unsigned char odtok(void); //funkce na urceni odtoku
unsigned char pot_hladina_zobr(void);
unsigned char pot_hladina_porov(void);
void radic1(int);
void radic2(int);
void timerInit(void);

char LEDdata1[36], LEDdata2[36];

int vyska_pwm = 6000;
int rychlost_pwm = 6000;

int main(void)
{

	int hladina=0; //aktualni vyska hladiny
	int hladina_min=5, hladina_max=100; //sepnuti cidla hladiny
	int hladina_poz=0, rychlost_odtoku=0;
	int hladina_poz_zobr=0;


	char stav_cerpadel; // pripad (0-15) pro switch
	char pom=0, error_start=0, spravnost=1;
	int rychlostTeceni=0;

	char errorDelay=0;

	DDRB=0xFF; // vystup PB5
	DDRC=0x00; // vstupn  - cerpadla
	DDRD=0xFF; // vystupn - 0-3 LED DRIVER, 4-6 do vstupu PLC
	DDRE=0xFF; // vystup PE3 - PWM rychlost odtoku
	DDRF=0x00; // vstup AD prevodniky
	_delay_ms(200);

	clrb(PORTD,1);
	clrb(PORTD,0);

	clrb(PORTD,3);
	clrb(PORTD,2);

	sei();    //globln povolen peruen


PORTE=0x00;
PORTB=0x00;







	timerInit();


	// nastaveni ADC prevodniku jednorazovy prevod, zarovnani do leva vysledku
	ADCSRA =  (1 << ADPS2); // Set ADC prescalar to 16 ~ 60KHz sample rate @ 1MHz  
//	ADMUX = (1 << REFS1) | (1 << REFS0) | (1 << ADLAR); // Set ADC reference to internal 2.56V
	ADMUX = (1 << REFS0)|(1 << ADLAR); // ADC reference - napajeci napeti
	ADMUX |= (1 << ADLAR); // Left adjust ADC result to allow easy 8 bit reading 
	ADCSRA |= (1 << ADEN);  // Enable ADC 

	LEDdata2[26] = 0;


	while (spravnost)
	{
		  // Vlastni program

			rychlost_odtoku = odtok(); //precte z potenc.
			rychlostTeceni++;
			if(rychlostTeceni == 10)
			{

				rychlostTeceni=0;
				if(bit_is_clear(PINC,0) )
				{
					hladina += CER1;
				}
				if(bit_is_clear(PINC,1) )
				{
					hladina += CER2;
				}
				if(bit_is_clear(PINC,2) )
				{
					hladina += CER3;
				}
				if(bit_is_clear(PINC,3) )
				{
					hladina += CER4;
				}
			
				if(hladina >100)
					hladina =101;
								
				
				if(hladina >0)
					hladina -= rychlost_odtoku;	//odecteni odtoku od hladiny, odtok je funkce adc prevodniku
				if(hladina <0)
					hladina = 0;
			
				radic1(hladina); //zobrazi hladinu

			}


			for(int i=21;i<26;i++) //vymazani pole
			{
				LEDdata2[i] = 0;   //zobrazovani stavu cerpadel
			}
			if(bit_is_clear(PINC,0) )
			{
				LEDdata2[21] = 1;
			}
			if(bit_is_clear(PINC,1) )
			{
				LEDdata2[22] = 1;
			}
			if(bit_is_clear(PINC,2) )
			{
				LEDdata2[23] = 1;
			}
			if(bit_is_clear(PINC,3) )
			{
				LEDdata2[24] = 1;
			}

			if(hladina>0)
				error_start = 1;


			if((hladina>0) && (hladina <100))
			{
				errorDelay=0;
				LEDdata2[26] = 0;
			}
			

			if( (hladina==0) && (error_start))
			{
				errorDelay++;
				if(errorDelay > 20)
				{
					LEDdata2[26] = 1;
					errorDelay=0;
				}
			}

			if( hladina > 100)
			{

				errorDelay++;
				if(errorDelay > 20)
				{
					LEDdata2[26] = 1;
					errorDelay=0;
				}
			}





			hladina_poz = pot_hladina_zobr();
			



			if(hladina >= hladina_min)
				PORTD |= HLAD_MIN_BIT;
			else
				PORTD &= ~HLAD_MIN_BIT;

			if( (hladina/5-1) >= (18-hladina_poz))
				PORTD |= HLAD_POZ_BIT;
			else
				PORTD &= ~HLAD_POZ_BIT;

			if(hladina >= hladina_max)
				PORTD |= HLAD_MAX_BIT;
			else
				PORTD &= ~HLAD_MAX_BIT;
				
					
				
					
				





			//urceni frekvence pro rychlost odtoku
			if(rychlost_odtoku ==0)	// porovnani aktualni a pozadovane hladiny
			{
			//	pwm_rychlost(20);
				rychlost_pwm=1000;
				LEDdata2[25] = 0;
			}
			if((rychlost_odtoku>0) && (rychlost_odtoku <=9))
			{
			//	pwm_rychlost(50);
				rychlost_pwm=800;
				LEDdata2[25] = 1;
			}
			if((rychlost_odtoku>9) && (rychlost_odtoku <=18))
			{
			//	pwm_rychlost(100);
				rychlost_pwm=600;
				LEDdata2[25] = 1;
			}
			if((rychlost_odtoku>18) && (rychlost_odtoku <=27))
			{
			//	pwm_rychlost(150);
				rychlost_pwm=400;
				LEDdata2[25] = 1;
			}
			if((rychlost_odtoku>27) && (rychlost_odtoku <=36))
			{
			//	pwm_rychlost(200);
				rychlost_pwm=200;
				LEDdata2[25] = 1;
			}


				//urceni frekvence pro vysku hladiny
			//if(hladina ==0)	// porovnani aktualni a pozadovane hladiny
		
			if((hladina>0) && (hladina <=25))
			{
				vyska_pwm=1000;
			
			}
			if((hladina>26) && (hladina <=50))
			{
				vyska_pwm=800;
				
			}
			if((hladina>51) && (hladina <=75))
			{
				vyska_pwm=600;
			
			}
			if((hladina>76) && (hladina <=100))
			{
				vyska_pwm=400;
				
			}
			
			






			radic2(hladina_poz);
			_delay_ms(50);
	} //while


	while(1);
} //main





unsigned char read_adc(unsigned char kanal)  
{  
    ADMUX = (ADMUX & 0xE0) | kanal; 
	
    ADCSRA |= (1<<ADSC);  
    while (ADCSRA & (1<<ADSC));
    return ADCH;  
}  

unsigned char odtok(void)
{
	int tmp;
	tmp = read_adc(CH_0);
	tmp = (tmp*25)/255;
	return (unsigned char)tmp;
	//return (36/255)*read_adc(CH_0);
}

unsigned char pot_hladina_zobr(void)
{
	float tmp;
	tmp = read_adc(CH_1);
	tmp = (tmp*18)/255;
	if(tmp>17)
		tmp = 17;
	return (unsigned char)tmp;
//	return (108/255)*read_adc(CH_1);
}

unsigned char pot_hladina_porov(void)
{
	float tmp;
	tmp = read_adc(CH_1);
	tmp = (tmp*90)/255;
	tmp -=5;
	tmp /=5;
	tmp = 20 - tmp;
	return (unsigned char)tmp;
//	return (108/255)*read_adc(CH_1);
}

void radic1(int hladina)
{	
	int velikost;
	velikost = hladina/5;	//aktualni hladina prevedena na 20 dilku
	int i;


	for(i=0;i<36;i++) //vymazani pole leddata
	{
		LEDdata1[i] = 0;
	}

	// priparava dat pro radic 1, aktualni vyska hladiny
	for(i=0;i<velikost ;i++)
	{
		LEDdata1[20-i] = 1;
	}
	// posilani dat do radice 1
	LEDdata1[0] = 1; //prvni jednicka start bit
	for(i=0;i<36;i++)  //zapise do radice 1
	{
		if(LEDdata1[i])
		{
			setb(PORTD,0);
		}
		else
		{
			clrb(PORTD,0);
		}
		_delay_us(500);
		setb(PORTD,1);
		_delay_us(500);
		clrb(PORTD,1);
		_delay_us(500);
	}
}

void radic2(int zob_hladina)
{
	int velikost;
	velikost = zob_hladina;	//aktualni hladina prevedena na 18 dilku

	for(int i=0;i<21;i++) //vymazani pole leddata
	{
		LEDdata2[i] = 0;
	}

	LEDdata2[19-velikost] = 1;
	LEDdata2[1] = 1;
	LEDdata2[20] = 1;

	
	// posilani dat do radice 2	
	LEDdata2[0] = 1; //prvni jednicka start bit
	for(int i=0;i<36;i++)  //zapise do radice 2
	{
		if(LEDdata2[i])
		{
			setb(PORTD,2);
		}
		else
		{
			clrb(PORTD,2);
		}
		_delay_us(500);
		setb(PORTD,3);
		_delay_us(500);
		clrb(PORTD,3);
		_delay_us(500);
	}
}

void timerInit(void)
{
	TCCR3A = (1 << COM3A0) | (1 << COM3B0);
//	TCCR3B = (1 << CS31);
	TCCR3B = (1 << CS30);	//delicka 1 - maximalni frekvence
//	TCCR3B = (1 << CS30) | (1 << CS32); //delicka na zkousku
	ETIMSK |= (1 << OCIE3A) | (1 << OCIE3B);

	TCNT1 = 65000;
	TCNT3 = 65000;
}


ISR(TIMER3_COMPA_vect)
{
	OCR3A = TCNT3 + rychlost_pwm;
}

ISR(TIMER3_COMPB_vect)
{
	OCR3B = TCNT3 + vyska_pwm;
}
